VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Player"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F6CD03B0183"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

Private name As String
Private id As Integer
Private iAssets As Integer
Private tokenName As Integer
Private Balance As Integer
Private position As Integer
Private inDebtTo As player
Private inJail As Boolean
Private inJailCount As Integer
Private goJFC As Boolean
Private isComputer As Boolean
Private isBankrupt As Boolean
Private doubleCount As Integer
Private ownStreet(7, 2) As Boolean
Private bBoard As New Board
Private didAction As Boolean
Public Sub setId(iId As Integer)
    id = iId
End Sub
Public Function getDidAction() As Boolean
    getDidAction = didAction
End Function
Public Sub setDidAction(didIt As Boolean)
    didAction = didIt
End Sub

Public Sub setName(sName As String)
    name = sName
End Sub

Public Function getName() As String
    getName = name
End Function


Public Function getId() As Integer
    getId = id
End Function


Public Function getTokenName() As String
    getTokenName = tokenName
End Function

Public Function getBalance() As Integer
    getBalance = Balance
End Function

Public Function getPosition() As Integer
    getPosition = position
End Function

Public Function IsInJail() As Boolean
    IsInJail = inJail
End Function

Public Function getJailCount() As Integer
    getJailCount = inJailCount
End Function

Public Sub incJailCount()
    If inJailCount <= 1 Then
        inJailCount = inJailCount + 1
    Else
        Me.getOutOfJail
    End If
End Sub

Public Sub resetJailCount()
    inJailCount = 0
End Sub

Public Sub pay50GOJ()
    debit 50
    Me.getOutOfJail
End Sub

Public Function hasGoJFC() As Boolean
    hasGoJFC = goJFC
End Function

Public Sub useGOJFC()
    goJFC = False
    bBoard.getJFLDeck.insertJail
    Me.getOutOfJail
End Sub
Public Sub setHasGoJFC(bGoJFC As Boolean)
    goJFC = bGoJFC
End Sub
Public Sub goToJail()
    If position > 10 Then
        move (40 - position), True
        move 10, True
    Else
        move (10 - position), True
    End If
    MainWindow.showInfo "Go to jail!"
    MainWindow.MediaPlayer1.FileName = "jailthere.wav"
    MainWindow.MediaPlayer1.Enabled = True
    inJail = True
End Sub

Public Sub getOutOfJail()
    inJail = False
    Me.resetJailCount
End Sub

Public Function isBankrupt2() As Boolean
    isBankrupt2 = isBankrupt
End Function

Public Sub declareBankruptcy()
    Dim pos As Integer
    Dim pInDebtTo As player
    Set pInDebtTo = isInDebtTo
    For pos = 0 To 39
        If TypeOf bBoard.getCell(pos) Is Property Then
            Dim pProp As Property
            Set pProp = bBoard.getCell(pos)
            If pProp.getOwners Is Nothing Then
                MainWindow.showOwner pos
            Else
                If Me Is pProp.getOwners Then
                    If pInDebtTo Is Nothing Then
                        Me.noMoreOwn bBoard.getCell(pos)
                        pProp.Unmortgage
                        MainWindow.showMort pos
                        pProp.setOwner Nothing
                        If TypeOf bBoard.getCell(pos) Is Street Then
                            Dim sStreet As Street
                            Set sStreet = bBoard.getCell(pos)
                            Do While sStreet.getHotelCount > 0
                                sStreet.destroyHotel
                            Loop
                        End If
                        MainWindow.showOwner pos
                    Else
                        pInDebtTo.newlyOwn bBoard.getCell(pos)
                        Me.noMoreOwn bBoard.getCell(pos)
                        MainWindow.showOwner pos
                    End If
                End If
            End If
        End If
    Next
    MainWindow.showBankRupt
    isBankrupt = True
    Dim count As Integer
    count = 0
    Dim oldPos As Integer
    oldPos = position
    position = 0
    bBoard.getCell(oldPos).display
    For pos = 0 To (bBoard.getNumPlayer - 1)
        If bBoard.getPlayer(pos).isBankrupt2 = False Then
            count = count + 1
        End If
    Next
    If count = 1 Then
        MainWindow.Visible = False
        GameEnd.Visible = True
    End If
    bBoard.endTurn
End Sub

Public Function ownsSomething() As Boolean
    
End Function

Public Sub move(numCells As Integer, penalty As Boolean)
    MainWindow.UpdateTurnPlaying 2
    Dim oldPos As Integer
    oldPos = position
    'numCells = numCells Mod 40
    position = position + numCells
    bBoard.getCell(oldPos).display
    If (position >= 40 And penalty = False) Then
        MainWindow.MoveToken Me.getId, oldPos, 39
        oldPos = 0
        position = position - 40
        credit 200
    Else
        If position >= 40 Then
            MainWindow.MoveToken Me.getId, oldPos, 39
            oldPos = 0
            position = position - 40
        End If
    End If
    MainWindow.MoveToken Me.getId, oldPos, position
    If Me.isComputer2 Then
        MainWindow.UpdateTurnPlaying 2
    End If
End Sub

Public Sub debit(amount As Integer)
 MainWindow.MediaPlayer1.FileName = "pay.wav"
    MainWindow.MediaPlayer1.Enabled = True
   
    Balance = Balance - amount
    If Balance < 0 Then
        MainWindow.showNegBalance True
    Else
        MainWindow.showNegBalance False
    End If
    MainWindow.UpdatePlayers
End Sub

Public Sub credit(amount As Integer)
 MainWindow.MediaPlayer1.FileName = "buy.wav"
    MainWindow.MediaPlayer1.Enabled = True
   
    Balance = Balance + amount
    If Balance < 0 Then
        MainWindow.showNegBalance True
    Else
        MainWindow.showNegBalance False
    End If
    MainWindow.UpdatePlayers
End Sub
Public Sub autoMakeMoney(amount As Integer)
    Dim pass As Integer
    pass = 0
    Do While Balance < amount And pass < 5
        Dim pos As Integer
        pos = 0
        For pos = 0 To 39
            If TypeOf bBoard.getCell(pos) Is Property Then
            Select Case pass
                Case Is = 0
                    If TypeOf bBoard.getCell(pos) Is Utility Then
                        If Me.canMort(pos) Then
                            Me.mortgageProp pos
                        End If
                    End If
                Case Is = 1
                    If TypeOf bBoard.getCell(pos) Is Metro Then
                        If Me.canMort(pos) Then
                            Me.mortgageProp pos
                        End If
                    End If
                Case Is = 2
                    If TypeOf bBoard.getCell(pos) Is Street Then
                        If Me.canMort(pos) Then
                            Me.mortgageProp pos
                        End If
                    End If
                Case Is = 3
                    If TypeOf bBoard.getCell(pos) Is Street Then
                        Do While Me.canSellHotel(pos) And Balance < amount
                            Me.sellHotel (pos)
                        Loop
                        If Me.canMort(pos) And Balance < 0 Then
                            Me.mortgageProp pos
                        End If
                    End If
                Case Is = 4
                    Me.declareBankruptcy
            End Select
            End If
            If Balance >= amount Then
                Exit For
            End If
        Next
        pass = pass + 1
        If Balance >= amount Then
            Exit Do
        End If
    Loop
End Sub
Public Sub autoPlay(opt As Integer)
    If opt = 0 Then
        If Me.IsInJail Then
            If Me.hasGoJFC Then
                Me.useGOJFC
                bBoard.rollDice
                MainWindow.MediaPlayer1.FileName = "DICEROLL.wav"
                MainWindow.MediaPlayer1.Enabled = True
            Else
                If Balance >= 50 Then
                    Me.pay50GOJ
                MainWindow.MediaPlayer1.FileName = "DICEROLL.wav"
                MainWindow.MediaPlayer1.Enabled = True
                    bBoard.rollDice
                Else
                MainWindow.MediaPlayer1.FileName = "DICEROLL.wav"
                MainWindow.MediaPlayer1.Enabled = True
                    bBoard.rollDice
                End If
            End If
        Else
            MainWindow.MediaPlayer1.FileName = "DICEROLL.wav"
            MainWindow.MediaPlayer1.Enabled = True
            bBoard.rollDice
        End If
    End If
    If opt = 1 Then
        Dim mortCount As Integer
        mortCount = 0
        If Balance >= 500 Then
            Dim pos As Integer
            For pos = 0 To 39
                If Me.canUnmort(pos) Then
                    mortCount = mortCount + 1
                    Me.unmortgageProp (pos)
                End If
            Next
            If mortCount = 0 Then
                
            End If
        End If
        bBoard.getCell(Me.getPosition).doAction Me
    End If
    If opt = 2 Then
        If TypeOf bBoard.getCell(Me.getPosition) Is Property Then
            Dim pProp As Property
            Set pProp = bBoard.getCell(Me.getPosition)
            CellInfoWindow.computerThink
            If pProp.getOwners Is Nothing Then
                If Me.canBuy(position) Then
                MainWindow.MediaPlayer1.FileName = "BUY.wav"
            MainWindow.MediaPlayer1.Enabled = True
                    Me.buyProperty
                End If
            Else
                If pProp.getOwners Is Me Then
                Else
                MainWindow.MediaPlayer1.FileName = "PAY.wav"
            MainWindow.MediaPlayer1.Enabled = True
                    Me.payRent
                End If
            End If
        Else
            If TypeOf bBoard.getCell(Me.getPosition) Is LuxuryTax Or TypeOf bBoard.getCell(Me.getPosition) Is IncomeTax Then
                taxCellWindow.computerThink
                MainWindow.MediaPlayer1.FileName = "PAY.wav"
            MainWindow.MediaPlayer1.Enabled = True
                Me.payRent
            Else
                If TypeOf bBoard.getCell(Me.getPosition) Is JFL Then
                End If
            End If
        End If
        If Balance > 200 Then
            autoTrade
        End If
        If Balance < 100 Then
            If Balance < 0 Then
                Me.autoMakeMoney 0
            End If
            Me.autoMakeMoney 100
        End If
        Me.setDidAction True
        Dim maxTry As Integer
        Dim count As Integer
        count = 0
        If Balance > 200 Then
            For maxTry = 0 To 3
                For pos = 39 To 0 Step -1
                    If Me.canBuild(pos) Then
            MainWindow.MediaPlayer1.FileName = "BUILDING.wav"
            MainWindow.MediaPlayer1.Enabled = True
                        Me.buildHotel (pos)
                        count = count + 1
                    End If
                Next
                If count <= 2 Then
                    Exit For
                Else
                    count = 0
                End If
            Next
        End If
    End If
End Sub
Public Sub autoTrade()
        Dim pos As Integer
        Dim count As Integer
        Dim possibleTrade(7) As Integer
        count = 0
        Dim dist As Integer
        For dist = 0 To 7
            For pos = 0 To 2
                If (dist = 0 Or dist = 7) And pos <> 2 Then
                    If ownStreet(dist, pos) Then
                        count = count + 1
                    End If
                Else
                    If (dist <> 0 And dist <> 7) Then
                        If ownStreet(dist, pos) Then
                            count = count + 1
                        End If
                    End If
                End If
            Next
            If count = 1 And (dist = 0 Or dist = 7) Then
                possibleTrade(dist) = dist
            End If
            If count = 2 And (dist <> 0 Or dist <> 7) Then
                possibleTrade(dist) = dist
            End If
            count = 0
        Next
        For dist = 0 To 7
            If possibleTrade(dist) <> 0 Then
                For pos = 0 To 2
                    If ownStreet(dist, pos) = False Then
                        'MsgBox ((dist + 1) * 10) + pos + 1
                        possibleTrade(dist) = ((dist + 1) * 10) + pos + 1
                    End If
                Next
            End If
        Next
        For dist = 0 To 7
            If possibleTrade(dist) <> 0 Then
                For pos = 0 To 39
                    If TypeOf bBoard.getCell(pos) Is Street Then
                        Dim sStreet As New Street
                        Set sStreet = bBoard.getCell(pos)
                        If sStreet.getDistId = possibleTrade(dist) Then
                            Dim pProp As New Property
                            Set pProp = bBoard.getCell(pos)
                            If pProp.getOwners Is Nothing Then
                            Else
                                Dim prob As Integer
                                Randomize Timer
                                prob = Int((10000 - 1 + 1) * Rnd + 1)
                                prob = prob Mod 10
                                If prob > 4 Then
                                    Dim offerAmount As Integer
                                    offerAmount = (0.5 + ((prob / 10) / 20)) * pProp.getPrice
                                    If pProp.getOwners.isComputer2 Then
                                        sStreet.showInfo Me, 0
                                        CellInfoWindow.trade_Click
                                        TradingCardWindow.amount = offerAmount
                                        TradingCardWindow.computerThink
                                        TradingCardWindow.wantIt_Click
                                        TradingCardWindow.computerThink
                                        Me.doTrade pos, offerAmount
                                        'MsgBox "CPU trade for cell " & pos & " for " & offerAmount
                                    Else
                                        sStreet.showInfo Me, 0
                                        CellInfoWindow.trade_Click
                                        TradingCardWindow.amount = offerAmount
                                        TradingCardWindow.computerThink
                                        TradingCardWindow.wantIt_Click
                                    End If
                                End If
                                Exit For
                            End If
                        End If
                    End If
                Next
            End If
        Next
End Sub
Public Sub buyProperty()
        Dim pProp As Variant
        Set pProp = bBoard.getCell(position)
        Dim iPrice As Integer
        iPrice = pProp.getProp.getPrice
        debit iPrice
        Me.newlyOwn pProp
End Sub
Public Sub newlyOwn(pProp As Variant)
        pProp.getProp.setOwner Me
        MainWindow.showOwner pProp.getProp.getCell.getId
        If TypeOf pProp Is Street Then
            Dim iDist As Integer
            Dim iPos As Integer
            iDist = (pProp.getDistId / 10) - 1
            iPos = (pProp.getDistId Mod 10) - 1
            ownStreet(iDist, iPos) = True
        End If
End Sub
Public Sub noMoreOwn(pProp As Variant)
        If TypeOf pProp Is Street Then
            Dim iDist As Integer
            Dim iPos As Integer
            iDist = (pProp.getDistId / 10) - 1
            iPos = (pProp.getDistId Mod 10) - 1
            ownStreet(iDist, iPos) = False
        End If
End Sub
Public Function getRent() As Integer
Dim pProp As Property
Set pProp = bBoard.getCell(position)
getRent = bBoard.getCell(position).getRent

End Function
Public Sub payRent()
        Dim iRent As Integer
        If TypeOf bBoard.getCell(position) Is Property Then
            Dim pProp As Property
            Set pProp = bBoard.getCell(position)
            iRent = bBoard.getCell(position).getRent
            If pProp.getOwners Is Me Then
            Else
                If Me.isComputer2 And pProp.isMortgaged2 = False Then
                    debit iRent
                    pProp.getOwners.credit iRent
                Else
                    If Me.canPayRent(position) = 0 And pProp.isMortgaged2 = False Then
                        debit iRent
                        pProp.getOwners.credit iRent
                    End If
                End If
            End If
        End If
        If TypeOf bBoard.getCell(position) Is LuxuryTax Or TypeOf bBoard.getCell(position) Is IncomeTax Then
            Dim vTax As Variant
            Set vTax = bBoard.getCell(position)
            iRent = vTax.getRent
            If TypeOf bBoard.getCell(position) Is IncomeTax Then
                If ((Me.calcAssets * 0.1) < iRent) Then
                    iRent = (Me.calcAssets * 0.1)
                End If
            End If
            If Me.isComputer2 Then
                debit iRent
            Else
                If Me.canPayTax(position) = 0 Then
                    debit iRent
                End If
            End If
        End If
End Sub

Public Sub unmortgageProp(cellId As Integer)
    If TypeOf bBoard.getCell(cellId) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(cellId)
        If Me.canUnmort(cellId) Then
            pProp.Unmortgage
            debit (pProp.getPrice * 1.1)
            MainWindow.showMort cellId
        End If
    End If
End Sub

Public Sub mortgageProp(cellId As Integer)
    If TypeOf bBoard.getCell(cellId) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(cellId)
        If Me.canMort(cellId) Then
            pProp.Mortgage
            credit pProp.getMortgage
            MainWindow.showMort cellId
        End If
    End If
End Sub
Public Function canSellHotel(cellId As Integer) As Boolean
    canSellHotel = False
    If TypeOf bBoard.getCell(cellId) Is Street Then
        Dim sStreet As Street
        Set sStreet = bBoard.getCell(cellId)
        If Me Is sStreet.getProp.getOwners Then
            If sStreet.getHotelCount > 0 Then
                canSellHotel = True
            Else
                canSellHotel = False
            End If
        End If
    End If
End Function
Public Function canBuild(cellId As Integer) As Boolean
    canBuild = False
    If TypeOf bBoard.getCell(cellId) Is Street Then
        Dim sStreet As Street
        Set sStreet = bBoard.getCell(cellId)
        If Me Is sStreet.getProp.getOwners Then
            Dim iDist As Integer
            iDist = (sStreet.getDistId / 10) - 1
            If sStreet.getHotelCost <= Balance And ownDist(iDist) And sStreet.getHotelCount < 4 And sStreet.getProp.isMortgaged2 = False Then
                canBuild = True
            Else
                canBuild = False
            End If
        End If
    End If
End Function
Public Function canUnmort(cellId As Integer) As Boolean
    canUnmort = False
    If TypeOf bBoard.getCell(cellId) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(cellId)
        If pProp.getOwners Is Me Then
            If (pProp.getMortgage * 1.1) <= Balance And pProp.isMortgaged2 = True Then
                canUnmort = True
            Else
                canUnmort = False
            End If
        Else
            canUnmort = False
        End If
    End If
End Function
Public Function canMort(cellId As Integer) As Boolean
    canMort = False
    If TypeOf bBoard.getCell(cellId) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(cellId)
        If pProp.getOwners Is Nothing Then
            canMort = False
        Else
            If pProp.getOwners Is Me Then
                If pProp.isMortgaged2 = False Then
                    If TypeOf bBoard.getCell(cellId) Is Street Then
                        If bBoard.getCell(cellId).getHotelCount <= 0 Then
                            canMort = True
                        Else
                            canMort = False
                        End If
                    Else
                        canMort = True
                    End If
                End If
            End If
        End If
    End If
End Function
Public Function canBuy(cellId As Integer) As Boolean
    canBuy = False
    If TypeOf bBoard.getCell(cellId) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(cellId)
        If pProp.getPrice <= Balance And pProp.getOwners Is Nothing Then
            canBuy = True
        End If
    End If
End Function
Public Function ownDist(iDist As Integer) As Boolean
    Dim iPos As Integer
    Dim bOwnsDist As Boolean
    bOwnsDist = False
    ownStreet(0, 2) = True
    ownStreet(7, 2) = True
    For iPos = 0 To 2
        If ownStreet(iDist, iPos) Then
            bOwnsDist = True
        Else
            bOwnsDist = False
            Exit For
        End If
    Next
    ownDist = bOwnsDist
End Function

Public Sub buildHotel(cellId As Integer)
    If TypeOf bBoard.getCell(cellId) Is Street Then
        If canBuild(cellId) Then
            Dim sStreet As Street
            Set sStreet = bBoard.getCell(cellId)
            sStreet.addHotel
            Dim iCost As Integer
            iCost = sStreet.getHotelCost
            debit iCost
            MainWindow.showHotel cellId
        End If
    End If
End Sub

Public Sub sellHotel(cellId As Integer)
    If TypeOf bBoard.getCell(cellId) Is Street Then
        Dim sStreet As Street
        Set sStreet = bBoard.getCell(cellId)
        If Me Is sStreet.getProp.getOwners Then
            Dim iCost As Integer
            iCost = sStreet.getHotelCost
            If canSellHotel(cellId) Then
                sStreet.destroyHotel
                credit iCost
                MainWindow.showHotel cellId
            End If
        End If
    End If
End Sub

Public Sub offerTrade(cellId As Integer, amount As Integer)
    Dim pProp As Property
    Set pProp = bBoard.getCell(cellId)
    TradingCardWindow.seeTrade cellId, pProp.getOwners, amount
    If pProp.getOwners.isComputer2 Then
        TradingCardWindow.computerThink
        Dim ratio As Integer
        ratio = amount / pProp.getPrice
        Dim p As Integer
        If (ratio <= 0.5) Then
            p = 0
        Else
            p = (ratio - 0.5) * 20
        End If
        Dim prob As Integer
        Randomize Timer
        prob = Int((10000 - 1 + 1) * Rnd + 1)
        prob = prob Mod 10
        If prob <= p Then
            doTrade cellId, amount
        Else
        End If
    End If
End Sub

Public Sub doTrade(cellId As Integer, amount As Integer)
    Dim pProp As Variant
    Set pProp = bBoard.getCell(cellId)
    pProp.getProp.getOwners.noMoreOwn pProp
    pProp.getProp.getOwners.credit amount
    Me.debit amount
    Me.newlyOwn pProp
End Sub
Public Function canPayRent(cellId As Integer) As Integer
        Dim iRent As Integer
        If TypeOf bBoard.getCell(position) Is Property Then
            Dim pProp As Property
            Set pProp = bBoard.getCell(position)
            iRent = pProp.getRent
            If iRent > Balance Then
                MainWindow.showNegBalance True
                canPayRent = iRent - Balance
            Else
                canPayRent = 0
            End If
        End If
End Function
Public Function canPayTax(cellId As Integer) As Integer
        Dim iRent As Integer
        If TypeOf bBoard.getCell(position) Is LuxuryTax Or TypeOf bBoard.getCell(position) Is IncomeTax Then
            Dim vTax As Variant
            Set vTax = bBoard.getCell(position)
            iRent = vTax.getRent
            If TypeOf bBoard.getCell(position) Is IncomeTax Then
                If ((Me.calcAssets * 0.1) < iRent) Then
                    iRent = (Me.calcAssets * 0.1)
                End If
            End If
            If iRent > Balance Then
                MainWindow.showNegBalance True
                canPayTax = iRent - Balance
            Else
                canPayTax = 0
            End If
        End If
End Function

Public Function isInDebtTo() As player
    If TypeOf bBoard.getCell(position) Is Property Then
        Dim pProp As Property
        Set pProp = bBoard.getCell(position)
        If pProp.getOwners Is Nothing Then
            Set isInDebtTo = Nothing
        Else
            If pProp.getOwners Is Me Then
                Set isInDebtTo = Nothing
            Else
                Set isInDebtTo = pProp.getOwners
            End If
        End If
    Else
        Set isInDebtTo = Nothing
    End If
End Function
Public Function getDoubleCount() As Integer
    getDoubleCount = doubleCount
End Function

Public Sub incDoubleCount()
    doubleCount = doubleCount + 1
End Sub

Public Sub resetDoubleCount()
    doubleCount = 0
End Sub

Public Function isComputer2() As Boolean
    isComputer2 = isComputer
End Function

Public Function calcAssets() As Integer
    Dim assets As Integer
    assets = Balance
    Dim pos As Integer
    For pos = 0 To 39
        If TypeOf bBoard.getCell(pos) Is Property Then
            Dim pProp As Property
            Set pProp = bBoard.getCell(pos)
            If pProp.getOwners Is Nothing Then
            Else
                If Me Is pProp.getOwners Then
                    If pProp.isMortgaged2 = False Then
                        assets = pProp.getPrice + assets
                        If TypeOf bBoard.getCell(pos) Is Street Then
                            Dim sStreet As Street
                            Set sStreet = bBoard.getCell(pos)
                            assets = (sStreet.getHotelCount * sStreet.getHotelCost) + assets
                        End If
                    Else
                        assets = (pProp.getPrice / 2) + assets
                    End If
                End If
            End If
        End If
    Next
    calcAssets = assets
End Function

Public Sub init(iId As Integer, sName As String, bBoard1 As Board, is_Computer As Boolean, token_Name As Integer)
    id = iId
    name = sName
    doubleCount = 0
    Balance = 1500
    tokenName = token_Name
    isComputer = is_Computer
    Dim pos1 As Integer
    Dim pos2 As Integer
    For pos1 = 0 To 7
        For pos2 = 0 To 2
            ownStreet(pos1, pos2) = False
        Next
    Next
    inJail = False
    Set bBoard = bBoard1
End Sub





