VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Property"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F6CCD650164"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

Implements Cell

Private price As Integer

Private isOwnedBy As player

Private isMortgaged As Boolean

Private mCellObject As New Cell

Public Sub display()
    Cell_display
End Sub

Public Function getCell() As Cell
    Set getCell = mCellObject
End Function

Public Function getOwners() As player
    Set getOwners = isOwnedBy
End Function

Public Sub setOwner(owner As player)
    Set isOwnedBy = owner
End Sub

Public Function isMortgaged2() As Boolean
    isMortgaged2 = isMortgaged
End Function

Public Function getPrice() As Integer
    getPrice = price
End Function

Public Function getRent() As Integer
    If Me.isMortgaged2 Then
        getRent = 0
    Else
        getRent = 0.1 * price
    End If
End Function

Public Function getMortgage() As Integer
    getMortgage = 0.5 * price
End Function

Public Sub Mortgage()
    isMortgaged = True
End Sub

Public Sub Unmortgage()
    isMortgaged = False
End Sub

Private Function Cell_getId() As Integer
    Cell_getId = mCellObject.getId
End Function

Private Function Cell_getName() As String
    Cell_getName = mCellObject.getName
End Function

Private Function Cell_isOn(playerid As Integer) As Boolean
    Cell_isOn = mCellObject.IsOn(playerid)
End Function

Private Sub Cell_display()
    Call mCellObject.display
End Sub

Private Sub Cell_doAction(player As player)
    Call mCellObject.doAction(player)
End Sub

Private Sub Cell_showinfo()
    Call mCellObject.showInfo
End Sub
Public Sub doAction(player As player)
    Cell_doAction player
End Sub


Friend Sub init(cCell As Cell, iPrice As Integer)
    Set mCellObject = cCell
    price = iPrice
End Sub

