VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Board"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F6CC9280329"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
'This is the main game class. It  controls the flow of the game,  as well as all the components of the game (ie: Player, Dice, JFLDeck and the Cells on the game board).
Option Explicit
Public Text1 As TextBox
'##ModelId=3F80731401FE
Private currPlayer As Integer

'##ModelId=3F80731D03D3
Private numPlayers As Integer

'##ModelId=3F8073200394
Private players(8) As player

'##ModelId=3F8073280058
Private goCell As New Go

'##ModelId=3F8073340308
Private goToJailCell As New goToJail

'##ModelId=3F80733C02C9
Private jailCell As New Jail

'##ModelId=3F8073410097
Private olympicParkCell As New OlympicPark

'##ModelId=3F80734A0308
Private incomeTaxCell As New IncomeTax

'##ModelId=3F80735803A4
Private luxuryTaxCell As New LuxuryTax

'##ModelId=3F807363028B
Private JFLCells(6) As New JFL

'##ModelId=3F80736C0068
Private streetCells(22) As New Street

'##ModelId=3F80737D0162
Private utilityCells(2) As New Utility

'##ModelId=3F80738700E5
Private metroCells(4) As New Metro

'##ModelId=3F80738E00E5
Private deck As New JFLDeck

'##ModelId=3F80739B01EE
Private Dice1 As New Dice

'##ModelId=3F8073A0026B
Private Dice2 As New Dice

Public Sub deleteAllPlayer()
    Dim pos As Integer
    For pos = 0 To 8
        Set players(pos) = Nothing
    Next
End Sub
Public Function getJFLDeck() As JFLDeck
    Set getJFLDeck = deck
End Function
'##ModelId=3F8073BC0181
Public Sub addPlayer(playerInfo As player)
    Set players(numPlayers) = playerInfo
    numPlayers = numPlayers + 1
End Sub
Public Function getCurrPlayer() As player
    Set getCurrPlayer = players(currPlayer)
End Function
Public Function getNumPlayer() As Integer
    getNumPlayer = numPlayers
End Function

Public Function getPlayer(id As Integer) As player
    Set getPlayer = players(id)
End Function
'##ModelId=3F8073B00152
Public Sub shufflePlayers()
Dim iTemp(8) As Integer
Dim pTemp(8) As player
Dim Rand As Integer
Dim pos As Integer
Dim repRand As Integer
Dim foundSpot As Boolean
Dim iArr As Integer
iArr = numPlayers - 1
For pos = 0 To numPlayers
    foundSpot = False
    Randomize Timer
    Rand = Int((iArr - 0 + 1) * Rnd + 0)
    If iTemp(Rand) = 0 Then
        iTemp(Rand) = pos
    Else
        repRand = Rand
        Do While foundSpot = False
            If repRand = numPlayers Then
                repRand = 0
            End If
            If iTemp(repRand) = 0 Then
                iTemp(repRand) = pos
                foundSpot = True
            End If
            repRand = repRand + 1
        Loop
    End If
Next
For pos = 0 To iArr
    Set pTemp(iTemp(pos) - 1) = players(pos)
Next
For pos = 0 To iArr
    Set players(pos) = pTemp(pos)
    players(pos).setId pos
Next
End Sub

'##ModelId=3F8F3D1003CE
Public Sub playTurn()
    If players(currPlayer).isComputer2 = False Then
        rollDice
        getCell(players(currPlayer).getPosition).doAction players(currPlayer)
        MainWindow.UpdateTurnPlaying 1
    Else
        players(currPlayer).autoPlay 0
        players(currPlayer).autoPlay 1
        players(currPlayer).autoPlay 2
        players(currPlayer).autoPlay 3
        Me.endTurn
    End If
End Sub

'##ModelId=3F8073E002C9
Public Sub rollDice()
    Dice1.roll
    Dice2.roll
    If Dice1.getValue = Dice2.getValue Then
        players(currPlayer).incDoubleCount
        MainWindow.showInfo players(currPlayer).getName + ", you have rolled doubles, go again!"
        
    Else
        players(currPlayer).resetDoubleCount
    End If
    If players(currPlayer).getDoubleCount = 3 Then
    MainWindow.showInfo players(currPlayer).getName + ", you have rolled three doubles, go to jail!"
    MainWindow.MediaPlayer2.FileName = "newpolice.wav"
    MainWindow.MediaPlayer2.Enabled = True
        players(currPlayer).goToJail
    End If
    If players(currPlayer).IsInJail = True Then
        If players(currPlayer).getDoubleCount = 0 Then
            players(currPlayer).incJailCount
             MainWindow.showInfo players(currPlayer).getName + ", no doubles, stay in jail!"
            MainWindow.UpdateTurnPlaying 1
        Else
        MainWindow.showInfo "Good Job" + players(currPlayer).getName + ", you can now get out of jail!"
            players(currPlayer).getOutOfJail
            
        End If
    End If
    MainWindow.Showdice Dice1.getValue, Dice2.getValue
    If players(currPlayer).IsInJail = False Then
          players(currPlayer).move (Dice1.getValue + Dice2.getValue), False
    End If
   
End Sub

Public Sub endTurn()
    If players(currPlayer).getDidAction = False And (TypeOf getCell(players(currPlayer).getPosition) Is Property Or TypeOf getCell(players(currPlayer).getPosition) Is IncomeTax Or TypeOf getCell(players(currPlayer).getPosition) Is LuxuryTax) Then
            MainWindow.showInfo "You must do something before you end your turn"
            getCell(players(currPlayer).getPosition).doAction players(currPlayer)
    Else
        If players(currPlayer).getBalance < 0 And players(currPlayer).isBankrupt2 = False Then
            MainWindow.showInfo "You must make money first"
        Else
            If players(currPlayer).getDoubleCount = 0 Or players(currPlayer).isBankrupt2 Then
                Dim flag As Boolean
                flag = False
                Do While flag = False
                    If currPlayer = (numPlayers - 1) Then
                        currPlayer = 0
                    Else
                        currPlayer = currPlayer + 1
                    End If
                    If players(currPlayer).isBankrupt2 = True Then
                        flag = False
                    Else
                        flag = True
                    End If
                Loop
            End If
            players(currPlayer).setDidAction False
            If players(currPlayer).IsInJail = True And players(currPlayer).getDoubleCount > 0 Then
                players(currPlayer).setDidAction True
                players(currPlayer).resetDoubleCount
                endTurn
            Else
                If players(currPlayer).isComputer2 = False Then
                    MainWindow.UpdateTurnPlaying 0
                Else
                    MainWindow.UpdateTurnPlaying 2
                    Me.playTurn
                End If
            End If
        End If
    End If
    If players(currPlayer).isComputer2 = False Then
        MainWindow.showInJail
    End If
End Sub

Private Sub Class_Initialize()
    numPlayers = 0
    currPlayer = 0
    Set Dice1 = New Dice
    Set Dice2 = New Dice
End Sub

Public Sub init()
    currPlayer = 0
    numPlayers = 0
    deck.init Me
    Dim cCell(39) As New cell
    cCell(0).init 0, "GO", Me
    cCell(1).init 1, "Saint-Antoine", Me
    cCell(2).init 2, "JFL", Me
    cCell(3).init 3, "Saint-Jacques", Me
    cCell(4).init 4, "Income Tax", Me
    cCell(5).init 5, "Outremont", Me
    cCell(6).init 6, "Wellington", Me
    cCell(7).init 7, "JFL", Me
    cCell(8).init 8, "Centre", Me
    cCell(9).init 9, "Bridge", Me
    cCell(10).init 10, "Jail", Me
    cCell(11).init 11, "Notre-Dame", Me
    cCell(12).init 12, "Utility 1", Me
    cCell(13).init 13, "Saint-Sulpice", Me
    cCell(14).init 14, "Saint-Paul", Me
    cCell(15).init 15, "Guy-Concordia", Me
    cCell(16).init 16, "Saint-Laurent", Me
    cCell(17).init 17, "JFL", Me
    cCell(18).init 18, "Saint-Urbain", Me
    cCell(19).init 19, "De La Gauchetiere", Me
    cCell(20).init 20, "Parc Olympique", Me
    cCell(21).init 21, "Jarry", Me
    cCell(22).init 22, "JFL", Me
    cCell(23).init 23, "Jean Talon", Me
    cCell(24).init 24, "Saint-Zotique", Me
    cCell(25).init 25, "Vendome", Me
    cCell(26).init 26, "Saint-Catherine", Me
    cCell(27).init 27, "Crescent", Me
    cCell(28).init 28, "HQ", Me
    cCell(29).init 29, "Peel", Me
    cCell(30).init 30, "Police", Me
    cCell(31).init 31, "Mont-Royal", Me
    cCell(32).init 32, "Rachel", Me
    cCell(33).init 33, "JFL", Me
    cCell(34).init 34, "Saint-Joseph", Me
    cCell(35).init 35, "Bonaventure", Me
    cCell(36).init 36, "JFL", Me
    cCell(37).init 37, "Green", Me
    cCell(38).init 38, "Luxury Tax", Me
    cCell(39).init 39, "The Boulevard", Me
    jailCell.init cCell(10)
    incomeTaxCell.init cCell(4)
    luxuryTaxCell.init cCell(38)
    olympicParkCell.init cCell(20)
    goToJailCell.init cCell(30)
    goCell.init cCell(0)
    utilityCells(0).init cCell(12), 200
    utilityCells(1).init cCell(28), 200
    JFLCells(0).init cCell(2)
    JFLCells(1).init cCell(7)
    JFLCells(2).init cCell(17)
    JFLCells(3).init cCell(22)
    JFLCells(4).init cCell(33)
    JFLCells(5).init cCell(36)
    metroCells(0).init cCell(5), 300
    metroCells(1).init cCell(15), 300
    metroCells(2).init cCell(25), 300
    metroCells(3).init cCell(35), 300
    streetCells(0).init cCell(1), 90, 11
    streetCells(1).init cCell(3), 100, 12
    streetCells(2).init cCell(6), 130, 21
    streetCells(3).init cCell(8), 140, 22
    streetCells(4).init cCell(9), 150, 23
    streetCells(5).init cCell(11), 170, 31
    streetCells(6).init cCell(13), 180, 32
    streetCells(7).init cCell(14), 190, 33
    streetCells(8).init cCell(16), 210, 41
    streetCells(9).init cCell(18), 220, 42
    streetCells(10).init cCell(19), 230, 43
    streetCells(11).init cCell(21), 250, 51
    streetCells(12).init cCell(23), 260, 52
    streetCells(13).init cCell(24), 270, 53
    streetCells(14).init cCell(26), 290, 61
    streetCells(15).init cCell(27), 300, 62
    streetCells(16).init cCell(29), 310, 63
    streetCells(17).init cCell(31), 330, 71
    streetCells(18).init cCell(32), 350, 72
    streetCells(19).init cCell(34), 350, 73
    streetCells(20).init cCell(37), 400, 81
    streetCells(21).init cCell(39), 500, 82
End Sub

Public Function getCell(pos As Integer) As Variant
    Dim iInt As Integer
    Select Case pos
        Case Is = 1, 3, 6, 8, 9, 11, 13, 14, 16, 18, 19, 21, 23, 24, 26, 27, 29, 31, 32, 34, 37, 39
            For iInt = 0 To 21
                If streetCells(iInt).getProp.getCell.getId = pos Then
                    Set getCell = streetCells(iInt)
                    Exit For
                End If
            Next
        Case Is = 0
            Set getCell = goCell
        Case Is = 10
            Set getCell = jailCell
        Case Is = 20
            Set getCell = olympicParkCell
        Case Is = 30
            Set getCell = goToJailCell
        Case Is = 2, 7, 17, 22, 33, 36
            For iInt = 0 To 5
                If JFLCells(iInt).getCell.getId = pos Then
                    Set getCell = JFLCells(iInt)
                    Exit For
                End If
            Next
        Case Is = 4
            Set getCell = incomeTaxCell
        Case Is = 38
            Set getCell = luxuryTaxCell
        Case Is = 5, 15, 25, 35
            For iInt = 0 To 3
                If metroCells(iInt).getProp.getCell.getId = pos Then
                    Set getCell = metroCells(iInt)
                    Exit For
                End If
            Next
        Case Is = 12, 28
            For iInt = 0 To 1
                If utilityCells(iInt).getProp.getCell.getId = pos Then
                    Set getCell = utilityCells(iInt)
                    Exit For
                End If
            Next
    End Select
End Function


