VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "JFLDeck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private bBoard As New Board
Private deck(19) As New JFLCard
Private goJailInDeck As Boolean
Private position As Integer
Public Function getBoard() As Board
    Set getBoard = bBoard
End Function
Public Function setInDeck(bInDeck As Boolean)
    goJailInDeck = bInDeck
End Function
Public Function getInDeck() As Boolean
    getInDeck = goJailInDeck
End Function

Public Sub shuffle()
    Dim iTemp(19) As Integer
    Dim jTemp(19) As JFLCard
    Dim Rand As Integer
    Dim pos As Integer
    Dim repRand As Integer
    Dim foundSpot As Boolean
    For pos = 0 To 19
        foundSpot = False
        Randomize Timer
        Rand = Int((19 - 0 + 1) * Rnd + 0)
        If iTemp(Rand) = 0 Then
            iTemp(Rand) = pos
        Else
            repRand = Rand
            Do While foundSpot = False
                If repRand = 19 Then
                    repRand = 0
                End If
                If iTemp(repRand) = 0 Then
                    iTemp(repRand) = pos
                    foundSpot = True
                End If
                repRand = repRand + 1
            Loop
        End If
    Next
    For pos = 0 To 19
        Set jTemp(iTemp(pos)) = deck(pos)
    Next
    For pos = 0 To 19
        Set deck(pos) = jTemp(pos)
    Next
End Sub

Public Function getCard() As JFLCard
    If Me.getInDeck = True Then
        If deck(position) Is Nothing Then
        Else
            Set getCard = deck(position)
            If deck(position).getType = 1 Then
                Me.setInDeck False
            End If
        End If
    Else
        If deck(position).getType = 1 Then
            position = position + 1
            Set getCard = deck(position)
        Else
            Set getCard = deck(position)
        End If
    End If
    If position = 19 Then
        position = 0
    Else
        position = position + 1
    End If
End Function

Public Sub insertJail()
    Dim jailCard As JFLCard
    Dim pos As Integer
    For pos = 0 To 19
        If deck(pos).getType = 1 Then
            Set jailCard = deck(pos)
            Set deck(pos) = Nothing
        End If
    Next
    For pos = 0 To 19
        If deck(pos) Is Nothing And pos <> 19 Then
            Set deck(pos) = deck(pos + 1)
        End If
    Next
    Dim newPos As Integer
    If position = 0 Then
        newPos = 19
    Else
        newPos = position - 1
    End If
    For pos = 19 To newPos Step -1
        Set deck(pos) = deck(pos - 1)
    Next
    Set deck(newPos) = jailCard
    Me.setInDeck True
End Sub

Public Sub init(bBoard1 As Board)
    Set bBoard = bBoard1
    position = 0
    deck(0).init "Go to jail", 0, Me
    deck(1).init "Get Out of Jail Free Card", 1, Me
    deck(2).init "Pass Go, collect 200$", 2, Me
    deck(3).init "Collect $250 from bank", 3, Me
    deck(4).init "Collect $200 from bank", 4, Me
    deck(5).init "Collect $150 from bank", 5, Me
    deck(6).init "Collect $100 from bank", 6, Me
    deck(7).init "Collect $50 from bank", 7, Me
    deck(8).init "Pay $250 to bank", 8, Me
    deck(9).init "Pay $200 to bank", 9, Me
    deck(10).init "Pay $150 to bank", 10, Me
    deck(11).init "Pay $100 to bank", 11, Me
    deck(12).init "Pay $50 to bank", 12, Me
    deck(13).init "Advance to Green street", 13, Me
    deck(14).init "Advance to St-Laurent street", 14, Me
    deck(15).init "Move forward 7 cells", 15, Me
    deck(16).init "Move forward 11 cells", 16, Me
    deck(17).init "Move forward 5 cells", 17, Me
    deck(18).init "Move back 3 cells", 18, Me
    deck(19).init "Do Nothing", 19, Me
    Me.shuffle
    Me.setInDeck True
End Sub

