VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Street"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F6CCE280183"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

Implements Property

Private int_hotel As Integer
Private distId As Integer
Private mPropertyObject As New Property
Public Function getProp() As Property
    Set getProp = mPropertyObject
End Function
Public Function getDistId() As Integer
    getDistId = distId
End Function
Public Function getRent() As Integer
    If int_hotel = 0 Then
        getRent = Property_getRent
    Else
        getRent = getRentWithHotels(int_hotel)
    End If
End Function

Public Function getRentWithHotels(numHotels As Integer) As Integer
    Select Case numHotels
        Case Is = 1
            getRentWithHotels = Property_getPrice * 0.5
        Case Is = 2
            getRentWithHotels = Property_getPrice * 1.2
        Case Is = 3
            getRentWithHotels = Property_getPrice * 2
        Case Is = 4
            getRentWithHotels = Property_getPrice * 2.5
    End Select
End Function

Public Function getHotelCost() As Integer
    getHotelCost = Property_getPrice * 0.6
End Function

Public Function getHotelCount() As Integer
    getHotelCount = int_hotel
End Function

Public Function addHotel()
    If int_hotel < 4 Then
        int_hotel = int_hotel + 1
        display
    End If
End Function

Public Function destroyHotel()
    If int_hotel >= 0 Then
        int_hotel = int_hotel - 1
        display
    End If
End Function

Public Sub doAction(player As player)
    Property_doAction player
    If Property_getOwners Is Nothing Then
        showInfo player, 1
    Else
        If Property_getOwners.getId <> player.getId And getProp.isMortgaged2 = False Then
            showInfo player, 2
        Else
            player.setDidAction True
        End If
    End If
End Sub

Public Sub display()
    Property_display
End Sub

Public Sub showInfo(player As player, opt As Integer)
    Dim cellInfo(7) As Integer
    Dim owner As String
    cellInfo(0) = Property_getPrice
    cellInfo(1) = Property_getRent
    cellInfo(2) = Me.getRentWithHotels(1)
    cellInfo(3) = Me.getRentWithHotels(2)
    cellInfo(4) = Me.getRentWithHotels(3)
    cellInfo(5) = Me.getRentWithHotels(4)
    cellInfo(6) = Property_getMortgage
    cellInfo(7) = getHotelCost
    If player.getDidAction = True Or player.getPosition <> Me.getProp.getCell.getId Then
        If Property_getOwners Is Nothing Then
            opt = 0
            owner = ""
        Else
            owner = Property_getOwners.getName
            If player.getId = Property_getOwners.getId Then
                opt = 3
            Else
                If Me.getHotelCount <= 0 And player.getBalance >= 0 Then
                    opt = 4
                End If
            End If
        End If
    End If
    CellInfoWindow.showInfoCard Me.getProp.getCell.getId, (distId / 10), cellInfo(), opt, player, Me.getProp.getCell.getName, owner
End Sub

Private Function Property_getOwners() As player
    Set Property_getOwners = mPropertyObject.getOwners
End Function
Private Sub Property_setOwner(owner As player)
    Call mPropertyObject.setOwner(owner)
End Sub
Private Function Property_isMortgaged2() As Boolean
    Property_isMortgaged2 = mPropertyObject.isMortgaged2
End Function
Private Function Property_getPrice() As Integer
    Property_getPrice = mPropertyObject.getPrice
End Function
Private Function Property_getRent() As Integer
    Property_getRent = mPropertyObject.getRent
End Function
Private Sub Property_display()
    Call mPropertyObject.display
End Sub
Private Function Property_getMortgage() As Integer
    Property_getMortgage = mPropertyObject.getMortgage
End Function

Private Sub Property_mortgage()
    Call mPropertyObject.Mortgage
End Sub
Private Sub Property_unmortgage()
    Call mPropertyObject.Unmortgage
End Sub
Private Sub Property_doAction(player As player)
    Call mPropertyObject.doAction(player)
End Sub

Private Function Property_getCell() As cell
    Call mPropertyObject.getCell
End Function

Public Sub init(cCell As cell, iPrice As Integer, iId As Integer)
    mPropertyObject.init cCell, iPrice
    int_hotel = 0
    distId = iId
End Sub
