VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Utility"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F6CCE4602EB"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

'##ModelId=3F6CCE820397
Implements Property

'##ModelId=3F973BC80373
Private mPropertyObject As New Property
Public Function getProp() As Property
    Set getProp = mPropertyObject
End Function
'##ModelId=3F80665600F4
Public Function getRent() As Integer
    getRent = Property_getRent
End Function

'##ModelId=3F80640A03D3
Public Sub doAction(player As player)
    Property_doAction player
    If Property_getOwners Is Nothing Then
        showInfo player, 1
    Else
        If Property_getOwners.getId <> player.getId And getProp.isMortgaged2 = False Then
            showInfo player, 2
        Else
            player.setDidAction True
        End If
    End If
End Sub

'##ModelId=3F8064B9000A
Public Sub display()
    Property_display
End Sub

Public Sub showInfo(player As player, opt As Integer)
    Dim cellInfo(2) As Integer
    Dim owner As String
    cellInfo(0) = Property_getPrice
    cellInfo(1) = Property_getRent
    cellInfo(2) = Property_getMortgage
    If player.getDidAction = True Or player.getPosition <> Me.getProp.getCell.getId Then
        If Property_getOwners Is Nothing Then
            opt = 0
            owner = ""
        Else
            owner = Property_getOwners.getName
            If player.getId = Property_getOwners.getId Then
                opt = 3
            Else
                If player.getBalance >= 0 Then
                    opt = 4
                End If
            End If
        End If
    End If
    CellInfoWindow.showInfoCard Me.getProp.getCell.getId, 10, cellInfo(), opt, player, Me.getProp.getCell.getName, owner
End Sub

'##ModelId=3F973BC8039B
Private Function Property_getOwners() As player
    Set Property_getOwners = mPropertyObject.getOwners
End Function

'##ModelId=3F973BC803AF
Private Sub Property_setOwner(owner As player)
    Call mPropertyObject.setOwner(owner)
End Sub

'##ModelId=3F973BC803D7
Private Function Property_isMortgaged2() As Boolean
    Property_isMortgaged2 = mPropertyObject.isMortgaged2
End Function

'##ModelId=3F973BC90003
Private Function Property_getPrice() As Integer
    Property_getPrice = mPropertyObject.getPrice
End Function

'##ModelId=3F973BC90017
Private Function Property_getRent() As Integer
    Property_getRent = mPropertyObject.getRent
End Function

'##ModelId=3F973BC90035
Private Function Property_getMortgage() As Integer
    Property_getMortgage = mPropertyObject.getMortgage
End Function

'##ModelId=3F973BC90049
Private Sub Property_mortgage()
    Call mPropertyObject.Mortgage
End Sub

Private Sub Property_unmortgage()
    Call mPropertyObject.Unmortgage
End Sub
Private Sub Property_doAction(player As player)
    Call mPropertyObject.doAction(player)
End Sub
Private Sub Property_display()
    Call mPropertyObject.display
End Sub
Private Function Property_getCell() As cell
    Call mPropertyObject.getCell
End Function
Public Sub init(cCell As cell, iPrice As Integer)
    mPropertyObject.init cCell, iPrice
End Sub
